#ifndef LOG_H_
#define LOG_H_

#ifdef __cplusplus
extern "C" {
#endif
int uart_printf (const char *fmt, ...);
void InitLog();
void WriteLog(const char *fmt, ...);
void WriteLog2(const char *fmt, ...);
void PrintLog();
uint16_t GetOverwriteCount();
//#define LOG(format, ... ) WriteLog(format, __VA_ARGS__)
extern uint16_t g_LogWritePos;

enum LOG_LEVEL
{
    LOG_LEVEL_VERBOSE = 0,
    LOG_LEVEL_WARN    = 1,
    LOG_LEVEL_ERROR   = 2,
};
extern enum LOG_LEVEL g_LogLevel;
void LevelLog(enum LOG_LEVEL logLevel, const char *fmt, ...);



#define DBGLOG(...) LevelLog(LOG_LEVEL_VERBOSE, __VA_ARGS__)
#define WRNLOG(...) LevelLog(LOG_LEVEL_WARN, __VA_ARGS__)
#define ERRLOG(...) LevelLog(LOG_LEVEL_ERROR, __VA_ARGS__)


struct TRegLogEntry
{
	uint32_t tag;
	uint32_t reg0;
	uint32_t reg1;
	uint32_t reg2;
	uint32_t reg3;
};
void LogRegister(uint32_t tag, uint32_t reg0, uint32_t reg1, uint32_t reg2, uint32_t reg3);

typedef void (*CustomizePrint)(uint32_t tag, uint32_t reg0, uint32_t reg1, uint32_t reg2, uint32_t reg3);
void DumpRegisterLog(CustomizePrint fp);

#ifdef __cplusplus
}
#endif

#endif
